Imports System.IO

Module modCopyFolder
    Sub Main()
        Console.Write("Quellordner: ")
        Dim Source As String = Console.ReadLine()

        Console.WriteLine()
        Console.Write("Zielordner: ")
        Dim Destination As String = Console.ReadLine()

        If Source <> "" And Destination <> "" Then _
            CopyFolder(Source, Destination)
    End Sub

    Public Sub CopyFolder(ByVal Path As String, _
        ByVal NewPath As String, _
        Optional ByVal OverWrite As Boolean = True)

        'Wenn Ordner nicht existiert, erstellen.
        If Directory.Exists(NewPath) = False Then _
            Directory.CreateDirectory(NewPath)

        Dim i As Long

        'Dateien im Ordner:
        Dim Files() As String = Directory.GetFiles(Path)
        'Ordner im Ordner:
        Dim Dirs() As String = Directory.GetDirectories(Path)

        ' Dateien kopieren:
        For i = 0 To Files.Length - 1
            If OverWrite Then
                If File.Exists(NewPath & "\" & Files(i).ToString.Split("\") _
                    (Files(i).ToString.Split("\").Length - 1)) = True Then

                    ' Wenn Datei bereits existiert, lschen
                    File.Delete(NewPath & "\" & Files(i).ToString.Split("\") _
                        (Files(i).ToString.Split("\").Length - 1))
                End If
            End If

            'Datei kopieren
            File.Copy(Files(i).ToString, NewPath & "\" & _
            Files(i).ToString.Split("\") _
            (Files(i).ToString.Split("\").Length - 1))
        Next

        ' Unterverzeichnisse kopieren
        For i = 0 To Dirs.Length - 1
            If Dirs(i) <> NewPath Then

                ' Das Ganze nochmal mit dem aktuellen Unterordner
                CopyFolder(Dirs(i), NewPath & "\" & _
                    Dirs(i).ToString.Split("\") _
                    (Dirs(i).ToString.Split("\").Length - 1))
            End If
        Next
    End Sub
End Module
